public class OurArrayList<E> implements IList<E> {
    private E[] data;
    private int size;

    // size vs. capacity
    // current size = 0
    // max size (capacity) = 10

    public OurArrayList() {
        this.data = (E[])new Object[10];
        this.size = 0;
    }

    //[1, 2, 3]
    public String toString() {
        String elements = "";
        for (int i = 0; i < this.size; i++) {
            elements += this.data[i] + ", ";
        }
        if (elements.length() > 0) {
            elements = elements.substring(0, elements.length() - 2);
        }
        return "[" + elements + "]";
    }

    @Override
    public int size() {
        return this.size;
    }

    @Override
    public void set(int idx, E elem) {
        if (idx < 0 || idx > this.size) {
           throw new IllegalArgumentException("blah");
        }
        else if (idx == size) {
            add(elem);
        }
        this.data[idx] = elem;

    }

    @Override
    public E get(int idx) {
        return null;
    }

    @Override
    public void clear() {
        this.size = 0;
    }

    @Override
    public void add(int idx, E elem) {

    }

    @Override
    public void add(E elt) {
        if (this.size == this.data.length) {
            E[] newData = (E[])new Object[this.size * 2];
            for (int i = 0; i < this.data.length; i++) {
                newData[i] = this.data[i];
            }
            this.data = newData;
        }
        this.data[size] = elt;
        this.size++;
    }


}
